--[[ TODO:
    
    "Display Stockpile": 10x10 unshuffled unshifted stockpile to use as a digital display (map?)

    Logistic versions with "rotate"? + Blueprint
    
    Other ideas:
      "map pixel" -> combinator/lamp that changes map color based on signal
    
    Replace the ring by next() calls?
    
    FUCK FUCK FUCK FUCK FUCK
      Some major cosmic fuckery is preventing f(e) from being called during script_raised_revive
      even though event() DID FUCKING RECIEVE THE EVENT!!!!!!!!1111111
      (Also script_raised_revive is being canceled by creative mode?!)
    
  ]]
  
--[[ Bugs:
  
    better map color?

  ]]
  
--[[ Future:

  Freeform building:
    > Use generated graphic-less prototypes (528 prototypes for 32x32) > x = {}; for i=1,32 do for j=1,32 do x[(i<j) and (i..','..j) or (j..','..i)] = true end end; local i=0; for k,v in pairs(x) do i=i+1 end; print(i)
    > use simple entity "fake tile" for background/collision in blueprints
    > blueprints contain only fake tiles + invisible real entity
    > real thing uses (collision-free?) indestructible walls on the outside
      > selection priority of walls is 1
    > "Q" needs to be a cursor-only blueprint?
      > hand-building of "Q" needs to auto-detect same-tick ghosts
        > or "build" linked control always revives if cursor_stack name is appropriate
      
    > MULTIBLOCK: dynamically detect the correct combination of wall+stockpile floor?
      > then draw some kind of polygon over the walls to indicate the stockpile has formed
    
    > ON DEATH:
      create item-on-ground for all the stuff
    > ON REVIVE:
      pick up item-on-ground (as location-exact as possible)
      > also needs instant update of all stacks in this pile...
  
  ]]
  
--[[ Quirks / Won't Fixes:
    
    If a mod later changes stack sizes the icon sizes will be wrong until the stack is emptied.
  
  ]]
  
--[[ IMPOSSIBLE:

    Freeform building.
      > Inserters use collision box for targeting containers.
      > So even if they can be cheated by teleportation the animation would look shitty.
      > Supporting limited freeform would require a large amount of prototypes.
    
  ]]

---- CONFIG ----------------------------------------------------------------------------------------
local update_size     = 20 --how many stacks to update per cycle
local update_interval = 2  --how many ticks between update cycles )

---- STARTUP ---------------------------------------------------------------------------------------
require('util')
pcall(require,'ulocale') --why pcall?
local DEBUG = true
local function say(...) if DEBUG then print(...) end end
local MOD_NAME = 'eradicators-stockpile'
  
---- THE RING --------------------------------------------------------------------------------------
-- this is a ring structure that references global.stacks for easier updates
-- ring structures can not be stored in global due to the de/serialization recursion limit
-- as this is thus a *local* variable great care has to be taken to prevent desyncs
local ring = nil

---- RENDER POSITIONS ------------------------------------------------------------------------------
--generates a bunch of position offsets for use with stockpiles
local function create_matrix(width,scale,shift)
  scale = scale or 1
  local shift = (shift and shift or 0.25) * scale
  width = width - 1 -- becaues two divisions make three parts
  local m = {}
  for y=-width/2,width/2,1 do
    local k = 0
    for x=-width/2,width/2,1 do
      k = k+1
      m[#m+1] = {scale*x,(k%2==0) and (scale*y-shift) or (scale*y+shift)}
      end
    end
  return m
  end
local stockpiles = {}
local bases = {
  ['er:stockpile-medium'] = {width = 5 , scale = 0.8}, -- 5* 5
  ['er:stockpile-large' ] = {width = 10, scale = 1.0}, --10*10
  ['er:stockpile-huge'  ] = {width = 18, scale = 0.9}, --18*18
  }
local variants = {
  {postfix = ''                 , chaotic = true , jiggle = 0.25},
  {postfix = '-linear'          , chaotic = false, jiggle = 0.00},
  {postfix = '-passive-provider', chaotic = true , jiggle = 0.25},
  {postfix = '-storage'         , chaotic = true , jiggle = 0.25},
  }
for name,data in pairs(bases) do
  local last = nil
  for k,var in pairs(variants) do
    local this = {
      matrix = create_matrix(data.width,data.scale,var.jiggle),
      chaotic = var.chaotic,
      base = name, --name of the item/first entity
      prev = prev,
      name = name..var.postfix,
      }
    stockpiles[this.name] = this
--link each variant to the next/previous one
    if last then last.next = this; this.prev = last end
    last = this
    end
  local first = stockpiles[name]
  first.prev = last; last.next = first
  end


---- HELPER FUNCTIONS ------------------------------------------------------------------------------
--get the center position of a bounding_box
local function get_middle(a,b) return a + (b-a)/2 end
local function get_box_center(box)
  return {x = get_middle(box.left_top.x,box.right_bottom.x),
          y = get_middle(box.left_top.y,box.right_bottom.y)}
  end  
--randomize order of entries in an array
--(random_generator produces equal sequences for seeds below 341-ish)
local function shuffle(tbl,seed) -- Fisher-Yates
  local rnd = math.random
  if seed then rnd = game.create_random_generator(); rnd.re_seed(seed+500) end
  for i = #tbl, 2, -1 do
    local j = rnd(1,i)
    tbl[i], tbl[j] = tbl[j], tbl[i]
    end
  return tbl
  end
--get a random LuaItemPrototype
local function get_random_item_prototype()
  local i = math.random(#game.item_prototypes)
  for k,v in pairs(game.item_prototypes) do
    i=i-1; if i==0 then i=v break end
    end
  return i, 'item/'..i.name
  end
---turns an array into a linked ring
--@tbl any table
--@key the keyword used to link to the next entry
local function make_linked_ring(tbl,key)
  if #tbl < 1 then error('Can not link table: too few elements.') end
  local key = key or 'next'
  tbl[#tbl][key] = tbl[1]
  --local keys = {}; for k,_ in pairs(tbl) do table.insert(keys,k) end; say(serpent.line(keys))
  local len = 0; for k,v in pairs(tbl) do len = len + 1 end
  if len ~= #tbl then error(string.format('Length mismatch len:%i #:%i',len,#tbl)) end
  for i=1,#tbl-1 do tbl[i][key] = tbl[i+1] end
  end
---returns a table containing all elements of @tbl for which all given functions return true
local function filter(tbl,...)
  local filters = {...}
  if #filters == 0 then return false end
  local r = {}
  for k,v in pairs(tbl) do
    local no_false = true
    for _,f in pairs(filters) do
      if not f(v,k,tbl) then no_false = false break end
      end
    if no_false then r[k] = v end
    end
  return r
  end
  
---- LOCALIZED RENDERING ACCESS --------------------------------------------------------------------
--use local variables for faster rendering api access
local r_is_valid;r_is_valid=function(...) r_is_valid=rendering.is_valid    return r_is_valid(...) end
local r_destroy ;r_destroy =function(...) r_destroy =rendering.destroy     return r_destroy (...) end
local r_sprite  ;r_sprite  =function(...) r_sprite  =rendering.draw_sprite return r_sprite  (...) end
local r_visible ;r_visible =function(...) r_visible =rendering.set_visible return r_visible (...) end

---- STACK RENDER MANAGEMENT------------------------------------------------------------------------
local function remove_render(id) if r_is_valid(id) then r_destroy(id) end end
local function remove_all_renders(stack)
  if stack.r then for _,id in pairs(stack.r) do remove_render(id) end end
  stack.r = nil
  end
local function are_all_renders_valid(stack)
  if not stack.r then return false end
  for _,id in pairs(stack.r) do if not r_is_valid(id) then return false end
  return true end
  end
  
---- STACK DATA MANAGEMENT  ------------------------------------------------------------------------
--removing volatile data from the stack causes a full update next round
local function reset_stack(stack)
  --say('reset stack')
  stack.empty = nil
  stack.name  = nil
  stack.count = nil
  remove_all_renders(stack)
  end
--preshuffles matrix to smooth animation on linear inventory insertion (inserters, loaders)
local function calculate_offsets (stockpile)
  --say('calculate offsets')
  if not stockpile.entity.valid then error('Can not calculate offsets: Entity invalid!') end
  local matrix = util.table.deepcopy(stockpiles[stockpile.entity.name].matrix)
  if stockpiles[stockpile.entity.name].chaotic then matrix = shuffle(matrix,stockpile.uid) end
  if #stockpile.stacks ~= #matrix then error('Incompatible Stockpile matrix: '..#matrix..' '..len) end
  for i,stack in pairs(stockpile.stacks) do
    reset_stack(stack)
    stack.offset = {x = matrix[i][1], y = matrix[i][2]}
    end
  end
  
---- STACK RENDER CREATION  ------------------------------------------------------------------------
--attaches sprites to the stockpile entity with an offset (teleportation compatible)
local function create_sprite_renderer(surface,sprite,x,y,entity)
  return function(dx,dy,scale)
    return r_sprite {
      sprite = sprite,
      target = entity,
      target_offset = {x+dx,y+dy},
      surface = surface,
      render_layer = 'object',
      x_scale = scale,
      y_scale = scale,
      }
    end
  end

local function create_stack_renders(stack)
--prevent crash on outdated savedata
  if not (stack.item and stack.item.valid_for_read 
   and stack.stockpile and stack.stockpile.entity.valid) then
    global.request_garbage_collection = true
    return
    end    
--skip to next round when missing offsets
  if not stack.offset then calculate_offsets(stack.stockpile) return end  
--attach sprites according to maximum stack size (larger stacks -> smaller icons)
  if stack.r then error('Stack already has renders!') end
  stack.name = stack.item.name
  stack.r = {}
  local sprite = 'item/'..stack.item.name
  local max = stack.item.prototype.stack_size  
  local rs = create_sprite_renderer(stack.stockpile.surface,sprite,stack.offset.x,stack.offset.y,stack.stockpile.entity)
  if max == 1 then -- rs(dx,dy,scale)
    stack.r[1  ] = rs(0,0,0.9)
  elseif max < 51 then
    stack.r[1  ] = rs(-0.1,0.1,0.7)
    stack.r[50 ] = rs(0.1,-0.1,0.7)
  elseif max < 101 then
    stack.r[1  ] = rs(0,-0.1,0.6)
    stack.r[50 ] = rs(-0.1,0.1,0.6)
    stack.r[100] = rs(0.1,0.1,0.6)
  else -- 100+
    stack.r[1  ] = rs(0,0.1,0.5)
    stack.r[50 ] = rs(0,-0.1,0.5)
    stack.r[100] = rs(-0.1,0,0.5)
    stack.r[200] = rs(0.1,0,0.5)
    end
  end

---- STACK UPDATER ---------------------------------------------------------------------------------
local function update_stack (stack)

--non-empty stack
  if stack.item.valid_for_read then
  
  --name changed
    if stack.name ~= stack.item.name then
      remove_all_renders(stack)
      create_stack_renders(stack)
      stack.count = nil
      end

  --count changed
    if stack.count ~= stack.item.count then
      stack.empty = nil
      if not are_all_renders_valid(stack) then reset_stack(stack) return end
      stack.count = stack.item.count
      for n,id in pairs(stack.r) do r_visible(id,stack.count>=n) end
      end

--empty stack
  elseif stack.item.valid then
    
  --wasn't empty last time
    if not stack.empty then
      --say('mark stack empty')
      if are_all_renders_valid(stack) then
        for _,id in pairs(stack.r) do r_visible(id,false) end
      else
        remove_all_renders(stack)
        stack.name = nil
        end
      stack.empty = true
      stack.count = nil
      end
  
--invalid stack
  else
    global.request_garbage_collection = true
    end

  end

---- BUILD STOCKPILE -------------------------------------------------------------------------------
local function build_stockpile(entity)
  --say('Stockpile built:',entity.name)
--create global data
  global.stacks   = global.stacks   or {}
  global.entities = global.entities or {}
--store stockpile entity
  local stockpile = {
    entity = entity,
    surface = entity.surface,
    uid = entity.unit_number,
    stacks = {}, --all stacks of this entity
    }
  global.entities[entity.unit_number] = stockpile
--store each LuaItemStack
  local inv = entity.get_inventory(defines.inventory.chest)
  for i=1,#inv do
    local new_stack = {item = inv[i], stockpile = stockpile}
    table.insert(global.stacks   , new_stack)
    table.insert(stockpile.stacks, new_stack)
    end
--randomize the global stack array + reset the update ring
  shuffle(global.stacks); ring = nil
  end

---- DESTROY STOCKPILE -----------------------------------------------------------------------------
local function destroy_stockpile(entity_or_uid)
  --say('request destroy stockpile')
  local uid = (type(entity_or_uid) == 'table') and entity_or_uid.unit_number or entity_or_uid   
  if not global.entities then return end
  local stockpile = global.entities[uid]
  if not stockpile then return end
  for _,stack in pairs(stockpile.stacks) do remove_all_renders(stack) end
  if stockpile.entity and stockpile.entity.valid then stockpile.entity.destroy() end
  stockpile.entity = {valid=false} --each stack still has a references to this
  global.entities[stockpile.uid] = nil
  global.request_garbage_collection = true
  end

  
---- GARBAGE COLLETION -----------------------------------------------------------------------------
--produces a reduction function that when called
--removes all elements from @tbl for which @f does not evaluate true or equivalent
--preserves keys of hash maps, compresses keys of numeric arrays
--@f: a function called on every element of @tbl
--@tbl: the input/output table
local function reducer(f) return function(tbl)
  local len = 0; for k,v in pairs(tbl) do len = len + 1 end
  if len == #tbl then --numeric array
    --say('reducing array')
    local next = 1
    for i=1,#tbl do
      if f(tbl[i],i,tbl) then
        tbl[next],tbl[i] = tbl[i],nil; next = next + 1
      else
        tbl[i] = nil
        end
      end
  else --hash map or mixed array
    --say('reducing hash map')
    for k,v in pairs(tbl) do if not f(v,k,tbl) then tbl[k] = nil end end
    end
  return tbl
  end end
local clean_stacks = reducer(function(this,key,tbl)
  if this.item and this.item.valid
    and this.stockpile 
    and this.stockpile.entity
    and this.stockpile.entity.valid
    then return true end
  remove_all_renders(this)
  end)
local clean_entities = reducer(function(this)
  return this.entity and this.entity.valid
  end)
--removes all stacks/entities whichs LuaObjects are not .valid anymore
--gracefully ignore missing global data (new worlds, old savegames)
local function fast_collect_garbage()
  global.request_garbage_collection = nil
  if global.entities then clean_entities(global.entities) end
  if global.stacks then
    clean_stacks(global.stacks)
    if #global.stacks == 0 then global.stacks = nil end --entities can stay as empty table...
    end
  ring = nil
  end
--triggers a full redraw of all renders (debugging / layout changes)
local function full_collect_garbage()
  fast_collect_garbage() --pre-clean
  for _,stockpile in pairs(global.entities or {}) do
    local inv = stockpile.entity.get_inventory(defines.inventory.chest)
    if #inv ~= #stockpile.stacks then --slot count changed!
      for _,stack in pairs(stockpile.stacks) do stack.item = nil end
      stockpile.stacks = {}
      for i=1,#inv do
        local new_stack = {item = inv[i], stockpile = stockpile}
        table.insert(global.stacks   , new_stack)
        table.insert(stockpile.stacks, new_stack)
        end
      shuffle(global.stacks); ring = nil
      end
    end
  fast_collect_garbage() --post-clean
  for _,stack in pairs(global.stacks or {}) do reset_stack(stack) stack.offset=nil end
  return true
  end

---- TICKER ----------------------------------------------------------------------------------------
--creates a local ring with *identical*(!) key <-> value mapping of global.stacks
--except the ring also maps each stack to the "next" stack for easy iteration
local function fill_ring()
  ring = {}
  for k,v in pairs(global.stacks) do ring[k] = {stack = v, idx = k} end  
  make_linked_ring(ring)
  end

local function ticker(e)
  --say('ticker start')
    
  if global.request_garbage_collection then
    --say('clearing garbage')
    fast_collect_garbage()
  
  elseif global.stacks then
    if not ring then fill_ring() end
    local this = global.next_idx and ring[global.next_idx] or ring[1]
    for _=1, update_size do update_stack(this.stack); this = this.next end
    global.next_idx = this.idx
    end      
    
  end

--[[
local function table_get_value_ref(tableA,path)
  local ref = tableA
  for i=1,#path do
    say('get',path[i],type(ref))
    if type(ref) == 'table' then ref = ref[ path[i] ] else return nil end
    end
  return ref
  end

---a for-loop compatible iterator factory
--@tbl: the table to iterate
--@f: a function called as f(value,index,table) to evaluate each table entry
--    entries for which @f does not return true are skipped during iteration
local function fpairs(tbl,f)
  f = f or function() return true end
  local next = _ENV.next
  local function iter(tbl,idx)
    local val = nil
    while true do
      idx,val = next(tbl,idx)
      if val == nil then return elseif f(val,idx,tbl) then return idx,val end
      end
    end
  return iter, tbl, nil
  end

--BROKEN *SOMEWHERE* due to lua custom tables not supporting next()
  
-- local function unlock_recipes()
  -- say('unlock')
  -- local get = function(path) return function(tbl) say(type(tbl)) return table_get_value_ref(tbl,path) end end
  -- for _,force in fpairs(game.forces,get{'technologies','stone-walls','researched'}) do
  -- say('force',force.name)
  -- for _,effect in fpairs(force.technologies['stone-walls'].effects,get{'recipe'}) do
    -- local recipe = force.recipes[effect.recipe]
    -- recipe.enabled = true
    -- recipe.reload() --when ingredients change?    
    -- end
    -- end
  -- end

--]]
  
  
local function unlock_recipes()
 local function reapply_recipes(tech)
 for _,effect in pairs(tech.effects or {}) do
   if effect.recipe then
     local recipe = tech.force.recipes[effect.recipe]
     recipe.enabled = true
     recipe.reload() --when ingredients change?
     end
   end
 end
 for _,force in pairs(game.forces) do
   local walls = force.technologies['stone-walls']
   if force.technologies['stone-walls'].researched then reapply_recipes(walls) end
   end
 end
  
---- EVENT MANAGEMENT ------------------------------------------------------------------------------
local build_events = {
  [defines.events.on_entity_cloned      ] = 'destination'   ,
  [defines.events.on_built_entity       ] = 'created_entity',
  [defines.events.on_robot_built_entity ] = 'created_entity',
  [defines.events.script_raised_revive  ] = 'entity'        ,
  }
local destroy_events = {
  [defines.events.on_entity_died        ] = 'entity'        ,
  [defines.events.on_robot_mined_entity ] = 'entity'        ,
  [defines.events.on_player_mined_entity] = 'entity'        ,
  [defines.events.script_raised_destroy ] = 'entity'        ,
  }
--@names: a mapping of names to the main key of an event
--@f: the event handler funtion
--@filter: an array of valid names for the main event key
local function event(names,f,filter)
  local n = {}; for k,_ in pairs(names) do n[#n+1] = k end
  local wrapper = function(e) e.this = e[names[e.name]] f(e) end
  script.on_event(n,wrapper)
  end
  
---- EVENTS ----------------------------------------------------------------------------------------
script.on_nth_tick(update_interval,ticker)
  
event(build_events,function(e)
  -- say('build recieved',serpent.block(e))
  if not stockpiles[e.this.name] then return end
  build_stockpile(e.this)
  end)
  
event(destroy_events,function(e)
  if not stockpiles[e.this.name] then return end
  destroy_stockpile(e.this)
  end)
  
script.on_configuration_changed(function(changes)
  local did_we_change = changes.mod_changes['er-stockpile']
  if did_we_change then
    if did_we_change.old_version then
      full_collect_garbage()
    else
      -- unlock_recipes() --HACKTEST, uncomment later!
      end
    end
  end)
    
script.on_event({'er:linked-control:rotate','er:linked-control:reverse-rotate'},function(e)
  local p = game.players[e.player_index]
  if p.cursor_stack.valid_for_read then return end --prevent rotating with full hands
  local this = p.selected
  if stockpiles[this and this.name] and p.can_reach_entity(this) then
    local old_uid = this.unit_number
    local prevnext = (e.input_name == 'er:linked-control:rotate') and 'next' or 'prev'
    local new_entity = this.surface.create_entity{ 
      name = stockpiles[this.name][prevnext].name,
      position = this.position,
      force = this.force,
      spill = false, player = nil, --prevent giving free placer items to the player
      raise_built = true,
      fast_replace = true,
      create_build_effect_smoke = false,
      }
    --did fast replace succeed?
    if this.valid then
      new_entity.destroy{raise_destroy=true}
    else
      destroy_stockpile(old_uid)
      build_stockpile(new_entity) --because raise_built doesn't properly trigger this (...why?)
      new_entity.last_user = p
      new_entity.get_inventory(defines.inventory.chest).sort_and_merge()
      end    
    global.request_garbage_collection = true
    end
  end)
  
---- COMMANDS --------------------------------------------------------------------------------------
  
-- Due to mod name change all stockpiles on all surfaces must be rebuilt!
_ENV .ON_USER_PANIC = function(e)
  if e.mod_changes[MOD_NAME] ~= nil then -- only if *this* mod changed
    full_collect_garbage()
    local stockpile_names = {}
    for name in pairs(game.entity_prototypes) do
      if name:find'^er:stockpile-' then
        table.insert(stockpile_names, name)
        end
      end    
    for _, s in pairs(game.surfaces) do
      for _, entity in pairs(s.find_entities_filtered{
        name = stockpile_names,
        }) do
        build_stockpile(entity)
        end
      end
    full_collect_garbage()
    end
  end
  
script.on_configuration_changed(ON_USER_PANIC)

--hidden commands that never conflict with other mods
local words_of_power = {
  ['er-stockpile:reset-renders'] = full_collect_garbage,
  ['er-stockpile:reset-render' ] = full_collect_garbage,
  ['er-stockpile:reset'        ] = full_collect_garbage,
  ["DON'T PANIC!"              ] = full_collect_garbage,
  }
local function try(f) return f and f() end
script.on_event(defines.events.on_console_chat,function(e)
  if not e.player_index then return end  --server commands have no player
  local p = game.players[e.player_index]
  if not (p and p.admin) then return end
  if try(words_of_power[e.message]) then
    game.print('eradicator: Fixed it')
    end
  end)
